<?php

namespace FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreateFromRequestHeaderOriginalDocumentIdentifierReference
 * StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:CreateFromRequestHeaderOriginalDocumentIdentifierReference
 * @subpackage Structs
 */
class CreateFromRequestHeaderOriginalDocumentIdentifierReference extends AbstractStructBase
{
    /**
     * The CustomerId
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $CustomerId;
    /**
     * The InternalReference
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $InternalReference;
    /**
     * The Type
     * @var string
     */
    public $Type;
    /**
     * Constructor method for
     * CreateFromRequestHeaderOriginalDocumentIdentifierReference
     * @uses CreateFromRequestHeaderOriginalDocumentIdentifierReference::setCustomerId()
     * @uses CreateFromRequestHeaderOriginalDocumentIdentifierReference::setInternalReference()
     * @uses CreateFromRequestHeaderOriginalDocumentIdentifierReference::setType()
     * @param string $customerId
     * @param string $internalReference
     * @param string $type
     */
    public function __construct($customerId = null, $internalReference = null, $type = null)
    {
        $this
            ->setCustomerId($customerId)
            ->setInternalReference($internalReference)
            ->setType($type);
    }
    /**
     * Get CustomerId value
     * @return string|null
     */
    public function getCustomerId()
    {
        return $this->CustomerId;
    }
    /**
     * Set CustomerId value
     * @param string $customerId
     * @return \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestHeaderOriginalDocumentIdentifierReference
     */
    public function setCustomerId($customerId = null)
    {
        // validation for constraint: string
        if (!is_null($customerId) && !is_string($customerId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($customerId, true), gettype($customerId)), __LINE__);
        }
        $this->CustomerId = $customerId;
        return $this;
    }
    /**
     * Get InternalReference value
     * @return string|null
     */
    public function getInternalReference()
    {
        return $this->InternalReference;
    }
    /**
     * Set InternalReference value
     * @param string $internalReference
     * @return \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestHeaderOriginalDocumentIdentifierReference
     */
    public function setInternalReference($internalReference = null)
    {
        // validation for constraint: string
        if (!is_null($internalReference) && !is_string($internalReference)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($internalReference, true), gettype($internalReference)), __LINE__);
        }
        $this->InternalReference = $internalReference;
        return $this;
    }
    /**
     * Get Type value
     * @return string|null
     */
    public function getType()
    {
        return $this->Type;
    }
    /**
     * Set Type value
     * @uses \FiloBlu\CegidY2\Api\CustomerOrderManagementService\EnumType\CustomerOrderDocumentTypeOriginTransfo::valueIsValid()
     * @uses \FiloBlu\CegidY2\Api\CustomerOrderManagementService\EnumType\CustomerOrderDocumentTypeOriginTransfo::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $type
     * @return \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestHeaderOriginalDocumentIdentifierReference
     */
    public function setType($type = null)
    {
        // validation for constraint: enumeration
        if (!\FiloBlu\CegidY2\Api\CustomerOrderManagementService\EnumType\CustomerOrderDocumentTypeOriginTransfo::valueIsValid($type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \FiloBlu\CegidY2\Api\CustomerOrderManagementService\EnumType\CustomerOrderDocumentTypeOriginTransfo', is_array($type) ? implode(', ', $type) : var_export($type, true), implode(', ', \FiloBlu\CegidY2\Api\CustomerOrderManagementService\EnumType\CustomerOrderDocumentTypeOriginTransfo::getValidValues())), __LINE__);
        }
        $this->Type = $type;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestHeaderOriginalDocumentIdentifierReference
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
