<?php

namespace FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreateFromRequestHeaderUserDefinedTableCollection
 * StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:CreateFromRequestHeaderUserDefinedTableCollection
 * @subpackage Structs
 */
class CreateFromRequestHeaderUserDefinedTableCollection extends AbstractStructBase
{
    /**
     * The UserDefinedTable
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestHeaderUserDefinedTable[]
     */
    public $UserDefinedTable;
    /**
     * Constructor method for CreateFromRequestHeaderUserDefinedTableCollection
     * @uses CreateFromRequestHeaderUserDefinedTableCollection::setUserDefinedTable()
     * @param \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestHeaderUserDefinedTable[] $userDefinedTable
     */
    public function __construct(array $userDefinedTable = array())
    {
        $this
            ->setUserDefinedTable($userDefinedTable);
    }
    /**
     * Get UserDefinedTable value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestHeaderUserDefinedTable[]|null
     */
    public function getUserDefinedTable()
    {
        return isset($this->UserDefinedTable) ? $this->UserDefinedTable : null;
    }
    /**
     * This method is responsible for validating the values passed to the setUserDefinedTable method
     * This method is willingly generated in order to preserve the one-line inline validation within the setUserDefinedTable method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateUserDefinedTableForArrayConstraintsFromSetUserDefinedTable(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $createFromRequestHeaderUserDefinedTableCollectionUserDefinedTableItem) {
            // validation for constraint: itemType
            if (!$createFromRequestHeaderUserDefinedTableCollectionUserDefinedTableItem instanceof \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestHeaderUserDefinedTable) {
                $invalidValues[] = is_object($createFromRequestHeaderUserDefinedTableCollectionUserDefinedTableItem) ? get_class($createFromRequestHeaderUserDefinedTableCollectionUserDefinedTableItem) : sprintf('%s(%s)', gettype($createFromRequestHeaderUserDefinedTableCollectionUserDefinedTableItem), var_export($createFromRequestHeaderUserDefinedTableCollectionUserDefinedTableItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The UserDefinedTable property can only contain items of type \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestHeaderUserDefinedTable, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set UserDefinedTable value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestHeaderUserDefinedTable[] $userDefinedTable
     * @return \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestHeaderUserDefinedTableCollection
     */
    public function setUserDefinedTable(array $userDefinedTable = array())
    {
        // validation for constraint: array
        if ('' !== ($userDefinedTableArrayErrorMessage = self::validateUserDefinedTableForArrayConstraintsFromSetUserDefinedTable($userDefinedTable))) {
            throw new \InvalidArgumentException($userDefinedTableArrayErrorMessage, __LINE__);
        }
        if (is_null($userDefinedTable) || (is_array($userDefinedTable) && empty($userDefinedTable))) {
            unset($this->UserDefinedTable);
        } else {
            $this->UserDefinedTable = $userDefinedTable;
        }
        return $this;
    }
    /**
     * Add item to UserDefinedTable value
     * @throws \InvalidArgumentException
     * @param \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestHeaderUserDefinedTable $item
     * @return \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestHeaderUserDefinedTableCollection
     */
    public function addToUserDefinedTable(\FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestHeaderUserDefinedTable $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestHeaderUserDefinedTable) {
            throw new \InvalidArgumentException(sprintf('The UserDefinedTable property can only contain items of type \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestHeaderUserDefinedTable, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->UserDefinedTable[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestHeaderUserDefinedTableCollection
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
