<?php

namespace FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreateFromRequestPaymentReceivedPayment StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:CreateFromRequestPaymentReceivedPayment
 * @subpackage Structs
 */
class CreateFromRequestPaymentReceivedPayment extends AbstractStructBase
{
    /**
     * The IsActive
     * @var bool
     */
    public $IsActive;
    /**
     * The RegisterOperationId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $RegisterOperationId;
    /**
     * Constructor method for CreateFromRequestPaymentReceivedPayment
     * @uses CreateFromRequestPaymentReceivedPayment::setIsActive()
     * @uses CreateFromRequestPaymentReceivedPayment::setRegisterOperationId()
     * @param bool $isActive
     * @param string $registerOperationId
     */
    public function __construct($isActive = null, $registerOperationId = null)
    {
        $this
            ->setIsActive($isActive)
            ->setRegisterOperationId($registerOperationId);
    }
    /**
     * Get IsActive value
     * @return bool|null
     */
    public function getIsActive()
    {
        return $this->IsActive;
    }
    /**
     * Set IsActive value
     * @param bool $isActive
     * @return \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestPaymentReceivedPayment
     */
    public function setIsActive($isActive = null)
    {
        // validation for constraint: boolean
        if (!is_null($isActive) && !is_bool($isActive)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isActive, true), gettype($isActive)), __LINE__);
        }
        $this->IsActive = $isActive;
        return $this;
    }
    /**
     * Get RegisterOperationId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getRegisterOperationId()
    {
        return isset($this->RegisterOperationId) ? $this->RegisterOperationId : null;
    }
    /**
     * Set RegisterOperationId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $registerOperationId
     * @return \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestPaymentReceivedPayment
     */
    public function setRegisterOperationId($registerOperationId = null)
    {
        // validation for constraint: string
        if (!is_null($registerOperationId) && !is_string($registerOperationId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($registerOperationId, true), gettype($registerOperationId)), __LINE__);
        }
        if (is_null($registerOperationId) || (is_array($registerOperationId) && empty($registerOperationId))) {
            unset($this->RegisterOperationId);
        } else {
            $this->RegisterOperationId = $registerOperationId;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestPaymentReceivedPayment
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
