<?php

namespace FiloBlu\CegidY2\Api\CustomerWcfService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CustomerInsertData StructType
 * Meta information extracted from the WSDL
 * - documentation: Data for creating a new customer record.
 * - nillable: true
 * - type: q60:CustomerInsertData
 * @subpackage Structs
 */
class CustomerInsertData extends CustomerInputData
{
    /**
     * The CustomerGuid
     * Meta information extracted from the WSDL
     * - documentation: [Added 2015/11 - V1300] [Optional].
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\InternalGuid
     */
    public $CustomerGuid;
    /**
     * The CustomerId
     * Meta information extracted from the WSDL
     * - documentation: [Added 2014/09 - V1105] [Optional] - Identifier of the customer to create. If not specified, it will be assigned automatically if the 'Automatic assignment of the customer code' option is ticked in the default store settings of the
     * user account used to log in. - Related to column [TIERS.T_TIERS].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CustomerId;
    /**
     * Constructor method for CustomerInsertData
     * @uses CustomerInsertData::setCustomerGuid()
     * @uses CustomerInsertData::setCustomerId()
     * @param \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\InternalGuid $customerGuid
     * @param string $customerId
     */
    public function __construct(\FiloBlu\CegidY2\Api\CustomerWcfService\StructType\InternalGuid $customerGuid = null, $customerId = null)
    {
        $this
            ->setCustomerGuid($customerGuid)
            ->setCustomerId($customerId);
    }
    /**
     * Get CustomerGuid value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\InternalGuid|null
     */
    public function getCustomerGuid()
    {
        return isset($this->CustomerGuid) ? $this->CustomerGuid : null;
    }
    /**
     * Set CustomerGuid value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\InternalGuid $customerGuid
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerInsertData
     */
    public function setCustomerGuid(\FiloBlu\CegidY2\Api\CustomerWcfService\StructType\InternalGuid $customerGuid = null)
    {
        if (is_null($customerGuid) || (is_array($customerGuid) && empty($customerGuid))) {
            unset($this->CustomerGuid);
        } else {
            $this->CustomerGuid = $customerGuid;
        }
        return $this;
    }
    /**
     * Get CustomerId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCustomerId()
    {
        return isset($this->CustomerId) ? $this->CustomerId : null;
    }
    /**
     * Set CustomerId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $customerId
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerInsertData
     */
    public function setCustomerId($customerId = null)
    {
        // validation for constraint: string
        if (!is_null($customerId) && !is_string($customerId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($customerId, true), gettype($customerId)), __LINE__);
        }
        if (is_null($customerId) || (is_array($customerId) && empty($customerId))) {
            unset($this->CustomerId);
        } else {
            $this->CustomerId = $customerId;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerInsertData
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
