<?php

namespace FiloBlu\CegidY2\Api\CustomerWcfService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for InternalGuid StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: q63:InternalGuid
 * @subpackage Structs
 */
class InternalGuid extends AbstractStructBase
{
    /**
     * The CheckGuid
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $CheckGuid;
    /**
     * The Guid
     * Meta information extracted from the WSDL
     * - base: xs:string
     * - minOccurs: 0
     * - nillable: true
     * - pattern: [\da-fA-F]{8}-[\da-fA-F]{4}-[\da-fA-F]{4}-[\da-fA-F]{4}-[\da-fA-F]{12}
     * - type: tns:guid
     * @var string
     */
    public $Guid;
    /**
     * Constructor method for InternalGuid
     * @uses InternalGuid::setCheckGuid()
     * @uses InternalGuid::setGuid()
     * @param bool $checkGuid
     * @param string $guid
     */
    public function __construct($checkGuid = null, $guid = null)
    {
        $this
            ->setCheckGuid($checkGuid)
            ->setGuid($guid);
    }
    /**
     * Get CheckGuid value
     * @return bool|null
     */
    public function getCheckGuid()
    {
        return $this->CheckGuid;
    }
    /**
     * Set CheckGuid value
     * @param bool $checkGuid
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\InternalGuid
     */
    public function setCheckGuid($checkGuid = null)
    {
        // validation for constraint: boolean
        if (!is_null($checkGuid) && !is_bool($checkGuid)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($checkGuid, true), gettype($checkGuid)), __LINE__);
        }
        $this->CheckGuid = $checkGuid;
        return $this;
    }
    /**
     * Get Guid value
     * @return string|null
     */
    public function getGuid()
    {
        return $this->Guid;
    }
    /**
     * Set Guid value
     * @param string $guid
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\InternalGuid
     */
    public function setGuid($guid = null)
    {
        // validation for constraint: string
        if (!is_null($guid) && !is_string($guid)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($guid, true), gettype($guid)), __LINE__);
        }
        // validation for constraint: pattern([\da-fA-F]{8}-[\da-fA-F]{4}-[\da-fA-F]{4}-[\da-fA-F]{4}-[\da-fA-F]{12})
        if (!is_null($guid) && !preg_match('/[\\da-fA-F]{8}-[\\da-fA-F]{4}-[\\da-fA-F]{4}-[\\da-fA-F]{4}-[\\da-fA-F]{12}/', $guid)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a literal that is among the set of character sequences denoted by the regular expression [\da-fA-F]{8}-[\da-fA-F]{4}-[\da-fA-F]{4}-[\da-fA-F]{4}-[\da-fA-F]{12}', var_export($guid, true)), __LINE__);
        }
        $this->Guid = $guid;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\InternalGuid
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
