<?php

namespace FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetListItemInventoryDetailByStore StructType
 * Meta information extracted from the WSDL
 * - documentation: [Added 2013/10 - V1104] - Returns the detail of the quantity available in stock for an item list (generic, without dimension, or SKU) and a store list.
 * @subpackage Structs
 */
class GetListItemInventoryDetailByStore extends AbstractStructBase
{
    /**
     * The inventoryStoreItemDetailRequest
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetListItemInventoryDetailByStore_Request
     */
    public $inventoryStoreItemDetailRequest;
    /**
     * The clientContext
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\RetailContext
     */
    public $clientContext;
    /**
     * Constructor method for GetListItemInventoryDetailByStore
     * @uses GetListItemInventoryDetailByStore::setInventoryStoreItemDetailRequest()
     * @uses GetListItemInventoryDetailByStore::setClientContext()
     * @param \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetListItemInventoryDetailByStore_Request $inventoryStoreItemDetailRequest
     * @param \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\RetailContext $clientContext
     */
    public function __construct(\FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetListItemInventoryDetailByStore_Request $inventoryStoreItemDetailRequest = null, \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\RetailContext $clientContext = null)
    {
        $this
            ->setInventoryStoreItemDetailRequest($inventoryStoreItemDetailRequest)
            ->setClientContext($clientContext);
    }
    /**
     * Get inventoryStoreItemDetailRequest value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetListItemInventoryDetailByStore_Request|null
     */
    public function getInventoryStoreItemDetailRequest()
    {
        return isset($this->inventoryStoreItemDetailRequest) ? $this->inventoryStoreItemDetailRequest : null;
    }
    /**
     * Set inventoryStoreItemDetailRequest value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetListItemInventoryDetailByStore_Request $inventoryStoreItemDetailRequest
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetListItemInventoryDetailByStore
     */
    public function setInventoryStoreItemDetailRequest(\FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetListItemInventoryDetailByStore_Request $inventoryStoreItemDetailRequest = null)
    {
        if (is_null($inventoryStoreItemDetailRequest) || (is_array($inventoryStoreItemDetailRequest) && empty($inventoryStoreItemDetailRequest))) {
            unset($this->inventoryStoreItemDetailRequest);
        } else {
            $this->inventoryStoreItemDetailRequest = $inventoryStoreItemDetailRequest;
        }
        return $this;
    }
    /**
     * Get clientContext value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\RetailContext|null
     */
    public function getClientContext()
    {
        return isset($this->clientContext) ? $this->clientContext : null;
    }
    /**
     * Set clientContext value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\RetailContext $clientContext
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetListItemInventoryDetailByStore
     */
    public function setClientContext(\FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\RetailContext $clientContext = null)
    {
        if (is_null($clientContext) || (is_array($clientContext) && empty($clientContext))) {
            unset($this->clientContext);
        } else {
            $this->clientContext = $clientContext;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetListItemInventoryDetailByStore
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
