<?php

namespace FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetListItemInventoryDetailByStoreResponse StructType
 * Meta information extracted from the WSDL
 * - documentation: [Added 2013/10 - V1104] - Returns the detail of the quantity available in stock for an item list (generic, without dimension, or SKU) and a store list.
 * @subpackage Structs
 */
class GetListItemInventoryDetailByStoreResponse extends AbstractStructBase
{
    /**
     * The GetListItemInventoryDetailByStoreResult
     * Meta information extracted from the WSDL
     * - documentation: Returns the list of inventory details
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetListItemInventoryDetailByStore_Reply
     */
    public $GetListItemInventoryDetailByStoreResult;
    /**
     * Constructor method for GetListItemInventoryDetailByStoreResponse
     * @uses GetListItemInventoryDetailByStoreResponse::setGetListItemInventoryDetailByStoreResult()
     * @param \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetListItemInventoryDetailByStore_Reply $getListItemInventoryDetailByStoreResult
     */
    public function __construct(\FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetListItemInventoryDetailByStore_Reply $getListItemInventoryDetailByStoreResult = null)
    {
        $this
            ->setGetListItemInventoryDetailByStoreResult($getListItemInventoryDetailByStoreResult);
    }
    /**
     * Get GetListItemInventoryDetailByStoreResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetListItemInventoryDetailByStore_Reply|null
     */
    public function getGetListItemInventoryDetailByStoreResult()
    {
        return isset($this->GetListItemInventoryDetailByStoreResult) ? $this->GetListItemInventoryDetailByStoreResult : null;
    }
    /**
     * Set GetListItemInventoryDetailByStoreResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetListItemInventoryDetailByStore_Reply $getListItemInventoryDetailByStoreResult
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetListItemInventoryDetailByStoreResponse
     */
    public function setGetListItemInventoryDetailByStoreResult(\FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetListItemInventoryDetailByStore_Reply $getListItemInventoryDetailByStoreResult = null)
    {
        if (is_null($getListItemInventoryDetailByStoreResult) || (is_array($getListItemInventoryDetailByStoreResult) && empty($getListItemInventoryDetailByStoreResult))) {
            unset($this->GetListItemInventoryDetailByStoreResult);
        } else {
            $this->GetListItemInventoryDetailByStoreResult = $getListItemInventoryDetailByStoreResult;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetListItemInventoryDetailByStoreResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
