<?php

namespace FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ResetShoppingCart_Request StructType
 * Meta information extracted from the WSDL
 * - documentation: Structure of parameters used for reset.
 * - nillable: true
 * - type: tns:ResetShoppingCart_Request
 * @subpackage Structs
 */
class ResetShoppingCart_Request extends AbstractStructBase
{
    /**
     * The ItemIdentifier
     * Meta information extracted from the WSDL
     * - documentation: [Optional].
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\ItemIdentifier
     */
    public $ItemIdentifier;
    /**
     * The WarehouseId
     * Meta information extracted from the WSDL
     * - documentation: Warehouse ID. - Related to column [DISPO.GQ_DEPOT].
     * - nillable: true
     * @var string
     */
    public $WarehouseId;
    /**
     * Constructor method for ResetShoppingCart_Request
     * @uses ResetShoppingCart_Request::setItemIdentifier()
     * @uses ResetShoppingCart_Request::setWarehouseId()
     * @param \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\ItemIdentifier $itemIdentifier
     * @param string $warehouseId
     */
    public function __construct(\FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\ItemIdentifier $itemIdentifier = null, $warehouseId = null)
    {
        $this
            ->setItemIdentifier($itemIdentifier)
            ->setWarehouseId($warehouseId);
    }
    /**
     * Get ItemIdentifier value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\ItemIdentifier|null
     */
    public function getItemIdentifier()
    {
        return isset($this->ItemIdentifier) ? $this->ItemIdentifier : null;
    }
    /**
     * Set ItemIdentifier value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\ItemIdentifier $itemIdentifier
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\ResetShoppingCart_Request
     */
    public function setItemIdentifier(\FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\ItemIdentifier $itemIdentifier = null)
    {
        if (is_null($itemIdentifier) || (is_array($itemIdentifier) && empty($itemIdentifier))) {
            unset($this->ItemIdentifier);
        } else {
            $this->ItemIdentifier = $itemIdentifier;
        }
        return $this;
    }
    /**
     * Get WarehouseId value
     * @return string|null
     */
    public function getWarehouseId()
    {
        return $this->WarehouseId;
    }
    /**
     * Set WarehouseId value
     * @param string $warehouseId
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\ResetShoppingCart_Request
     */
    public function setWarehouseId($warehouseId = null)
    {
        // validation for constraint: string
        if (!is_null($warehouseId) && !is_string($warehouseId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($warehouseId, true), gettype($warehouseId)), __LINE__);
        }
        $this->WarehouseId = $warehouseId;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\ResetShoppingCart_Request
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
