<?php

namespace FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CloseCardRequest StructType
 * Meta information extracted from the WSDL
 * - documentation: Close card.
 * - nillable: true
 * - type: tns:CloseCardRequest
 * @subpackage Structs
 */
class CloseCardRequest extends AbstractStructBase
{
    /**
     * The Comment
     * Meta information extracted from the WSDL
     * - documentation: Comment. - Related to column [MCARTEFIDLIG.MFL_COMMENTAIRE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Comment;
    /**
     * The LoyaltyCardId
     * Meta information extracted from the WSDL
     * - documentation: Card number. - Related to column [MCARTEFIDENT.MFC_NUMCARTE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $LoyaltyCardId;
    /**
     * The Reason
     * Meta information extracted from the WSDL
     * - documentation: Reason. - Related to column [MCARTEFIDLIG.MFL_MOTIFFID].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Reason;
    /**
     * Constructor method for CloseCardRequest
     * @uses CloseCardRequest::setComment()
     * @uses CloseCardRequest::setLoyaltyCardId()
     * @uses CloseCardRequest::setReason()
     * @param string $comment
     * @param string $loyaltyCardId
     * @param string $reason
     */
    public function __construct($comment = null, $loyaltyCardId = null, $reason = null)
    {
        $this
            ->setComment($comment)
            ->setLoyaltyCardId($loyaltyCardId)
            ->setReason($reason);
    }
    /**
     * Get Comment value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getComment()
    {
        return isset($this->Comment) ? $this->Comment : null;
    }
    /**
     * Set Comment value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $comment
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\CloseCardRequest
     */
    public function setComment($comment = null)
    {
        // validation for constraint: string
        if (!is_null($comment) && !is_string($comment)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($comment, true), gettype($comment)), __LINE__);
        }
        if (is_null($comment) || (is_array($comment) && empty($comment))) {
            unset($this->Comment);
        } else {
            $this->Comment = $comment;
        }
        return $this;
    }
    /**
     * Get LoyaltyCardId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getLoyaltyCardId()
    {
        return isset($this->LoyaltyCardId) ? $this->LoyaltyCardId : null;
    }
    /**
     * Set LoyaltyCardId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $loyaltyCardId
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\CloseCardRequest
     */
    public function setLoyaltyCardId($loyaltyCardId = null)
    {
        // validation for constraint: string
        if (!is_null($loyaltyCardId) && !is_string($loyaltyCardId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($loyaltyCardId, true), gettype($loyaltyCardId)), __LINE__);
        }
        if (is_null($loyaltyCardId) || (is_array($loyaltyCardId) && empty($loyaltyCardId))) {
            unset($this->LoyaltyCardId);
        } else {
            $this->LoyaltyCardId = $loyaltyCardId;
        }
        return $this;
    }
    /**
     * Get Reason value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getReason()
    {
        return isset($this->Reason) ? $this->Reason : null;
    }
    /**
     * Set Reason value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $reason
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\CloseCardRequest
     */
    public function setReason($reason = null)
    {
        // validation for constraint: string
        if (!is_null($reason) && !is_string($reason)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($reason, true), gettype($reason)), __LINE__);
        }
        if (is_null($reason) || (is_array($reason) && empty($reason))) {
            unset($this->Reason);
        } else {
            $this->Reason = $reason;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\CloseCardRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
