<?php

namespace FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetCustomerCardsRequest StructType
 * Meta information extracted from the WSDL
 * - documentation: Search criteria.
 * - nillable: true
 * - type: tns:GetCustomerCardsRequest
 * @subpackage Structs
 */
class GetCustomerCardsRequest extends AbstractStructBase
{
    /**
     * The ActiveCards
     * Meta information extracted from the WSDL
     * - documentation: Search based on the active card property. No filter applies, if the value is null.
     * - minOccurs: 0
     * - nillable: true
     * @var bool
     */
    public $ActiveCards;
    /**
     * The CustomerId
     * Meta information extracted from the WSDL
     * - documentation: Search on the customer's identifier.
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CustomerId;
    /**
     * The CustomerReference
     * Meta information extracted from the WSDL
     * - documentation: Search on customer's reference. - Related to column [MCARTEFIDENT.MFC_TIERS].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CustomerReference;
    /**
     * The StoreId
     * Meta information extracted from the WSDL
     * - documentation: Search on the store's identifier. No filter applies, if the value is null. - Related to column [MCARTEFIDENT.MFC_ETABLISSEMENT].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $StoreId;
    /**
     * Constructor method for GetCustomerCardsRequest
     * @uses GetCustomerCardsRequest::setActiveCards()
     * @uses GetCustomerCardsRequest::setCustomerId()
     * @uses GetCustomerCardsRequest::setCustomerReference()
     * @uses GetCustomerCardsRequest::setStoreId()
     * @param bool $activeCards
     * @param string $customerId
     * @param string $customerReference
     * @param string $storeId
     */
    public function __construct($activeCards = null, $customerId = null, $customerReference = null, $storeId = null)
    {
        $this
            ->setActiveCards($activeCards)
            ->setCustomerId($customerId)
            ->setCustomerReference($customerReference)
            ->setStoreId($storeId);
    }
    /**
     * Get ActiveCards value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return bool|null
     */
    public function getActiveCards()
    {
        return isset($this->ActiveCards) ? $this->ActiveCards : null;
    }
    /**
     * Set ActiveCards value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param bool $activeCards
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\GetCustomerCardsRequest
     */
    public function setActiveCards($activeCards = null)
    {
        // validation for constraint: boolean
        if (!is_null($activeCards) && !is_bool($activeCards)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($activeCards, true), gettype($activeCards)), __LINE__);
        }
        if (is_null($activeCards) || (is_array($activeCards) && empty($activeCards))) {
            unset($this->ActiveCards);
        } else {
            $this->ActiveCards = $activeCards;
        }
        return $this;
    }
    /**
     * Get CustomerId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCustomerId()
    {
        return isset($this->CustomerId) ? $this->CustomerId : null;
    }
    /**
     * Set CustomerId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $customerId
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\GetCustomerCardsRequest
     */
    public function setCustomerId($customerId = null)
    {
        // validation for constraint: string
        if (!is_null($customerId) && !is_string($customerId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($customerId, true), gettype($customerId)), __LINE__);
        }
        if (is_null($customerId) || (is_array($customerId) && empty($customerId))) {
            unset($this->CustomerId);
        } else {
            $this->CustomerId = $customerId;
        }
        return $this;
    }
    /**
     * Get CustomerReference value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCustomerReference()
    {
        return isset($this->CustomerReference) ? $this->CustomerReference : null;
    }
    /**
     * Set CustomerReference value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $customerReference
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\GetCustomerCardsRequest
     */
    public function setCustomerReference($customerReference = null)
    {
        // validation for constraint: string
        if (!is_null($customerReference) && !is_string($customerReference)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($customerReference, true), gettype($customerReference)), __LINE__);
        }
        if (is_null($customerReference) || (is_array($customerReference) && empty($customerReference))) {
            unset($this->CustomerReference);
        } else {
            $this->CustomerReference = $customerReference;
        }
        return $this;
    }
    /**
     * Get StoreId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getStoreId()
    {
        return isset($this->StoreId) ? $this->StoreId : null;
    }
    /**
     * Set StoreId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $storeId
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\GetCustomerCardsRequest
     */
    public function setStoreId($storeId = null)
    {
        // validation for constraint: string
        if (!is_null($storeId) && !is_string($storeId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($storeId, true), gettype($storeId)), __LINE__);
        }
        if (is_null($storeId) || (is_array($storeId) && empty($storeId))) {
            unset($this->StoreId);
        } else {
            $this->StoreId = $storeId;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\GetCustomerCardsRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
