<?php

namespace FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfGet_Line ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfGet_Line
 * @subpackage Arrays
 */
class ArrayOfGet_Line extends AbstractStructArrayBase
{
    /**
     * The Get_Line
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Line[]
     */
    public $Get_Line;
    /**
     * Constructor method for ArrayOfGet_Line
     * @uses ArrayOfGet_Line::setGet_Line()
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Line[] $get_Line
     */
    public function __construct(array $get_Line = array())
    {
        $this
            ->setGet_Line($get_Line);
    }
    /**
     * Get Get_Line value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Line[]|null
     */
    public function getGet_Line()
    {
        return isset($this->Get_Line) ? $this->Get_Line : null;
    }
    /**
     * This method is responsible for validating the values passed to the setGet_Line method
     * This method is willingly generated in order to preserve the one-line inline validation within the setGet_Line method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateGet_LineForArrayConstraintsFromSetGet_Line(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfGet_LineGet_LineItem) {
            // validation for constraint: itemType
            if (!$arrayOfGet_LineGet_LineItem instanceof \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Line) {
                $invalidValues[] = is_object($arrayOfGet_LineGet_LineItem) ? get_class($arrayOfGet_LineGet_LineItem) : sprintf('%s(%s)', gettype($arrayOfGet_LineGet_LineItem), var_export($arrayOfGet_LineGet_LineItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Get_Line property can only contain items of type \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Line, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Get_Line value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Line[] $get_Line
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfGet_Line
     */
    public function setGet_Line(array $get_Line = array())
    {
        // validation for constraint: array
        if ('' !== ($get_LineArrayErrorMessage = self::validateGet_LineForArrayConstraintsFromSetGet_Line($get_Line))) {
            throw new \InvalidArgumentException($get_LineArrayErrorMessage, __LINE__);
        }
        if (is_null($get_Line) || (is_array($get_Line) && empty($get_Line))) {
            unset($this->Get_Line);
        } else {
            $this->Get_Line = $get_Line;
        }
        return $this;
    }
    /**
     * Add item to Get_Line value
     * @throws \InvalidArgumentException
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Line $item
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfGet_Line
     */
    public function addToGet_Line(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Line $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Line) {
            throw new \InvalidArgumentException(sprintf('The Get_Line property can only contain items of type \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Line, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Get_Line[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Line|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Line|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Line|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Line|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Line|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Get_Line
     */
    public function getAttributeName()
    {
        return 'Get_Line';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfGet_Line
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
