<?php

namespace FiloBlu\CegidY2\Api\SaleDocumentService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetOmniChannelLine StructType
 * Meta information extracted from the WSDL
 * - documentation: Omni-Channel data
 * - nillable: true
 * - type: tns:GetOmniChannelLine
 * @subpackage Structs
 */
class GetOmniChannelLine extends AbstractStructBase
{
    /**
     * The FollowUpStatus
     * Meta information extracted from the WSDL
     * - documentation: Line follow-up status.
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $FollowUpStatus;
    /**
     * The WarehouseId
     * Meta information extracted from the WSDL
     * - documentation: Line warehouse.
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $WarehouseId;
    /**
     * Constructor method for GetOmniChannelLine
     * @uses GetOmniChannelLine::setFollowUpStatus()
     * @uses GetOmniChannelLine::setWarehouseId()
     * @param string $followUpStatus
     * @param string $warehouseId
     */
    public function __construct($followUpStatus = null, $warehouseId = null)
    {
        $this
            ->setFollowUpStatus($followUpStatus)
            ->setWarehouseId($warehouseId);
    }
    /**
     * Get FollowUpStatus value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFollowUpStatus()
    {
        return isset($this->FollowUpStatus) ? $this->FollowUpStatus : null;
    }
    /**
     * Set FollowUpStatus value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $followUpStatus
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetOmniChannelLine
     */
    public function setFollowUpStatus($followUpStatus = null)
    {
        // validation for constraint: string
        if (!is_null($followUpStatus) && !is_string($followUpStatus)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($followUpStatus, true), gettype($followUpStatus)), __LINE__);
        }
        if (is_null($followUpStatus) || (is_array($followUpStatus) && empty($followUpStatus))) {
            unset($this->FollowUpStatus);
        } else {
            $this->FollowUpStatus = $followUpStatus;
        }
        return $this;
    }
    /**
     * Get WarehouseId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getWarehouseId()
    {
        return isset($this->WarehouseId) ? $this->WarehouseId : null;
    }
    /**
     * Set WarehouseId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $warehouseId
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetOmniChannelLine
     */
    public function setWarehouseId($warehouseId = null)
    {
        // validation for constraint: string
        if (!is_null($warehouseId) && !is_string($warehouseId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($warehouseId, true), gettype($warehouseId)), __LINE__);
        }
        if (is_null($warehouseId) || (is_array($warehouseId) && empty($warehouseId))) {
            unset($this->WarehouseId);
        } else {
            $this->WarehouseId = $warehouseId;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetOmniChannelLine
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
