<?php

namespace FiloBlu\CegidY2\Api\SaleDocumentService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Get_Header StructType
 * Meta information extracted from the WSDL
 * - documentation: Sales document header
 * - nillable: true
 * - type: tns:Get_Header
 * @subpackage Structs
 */
class Get_Header extends AbstractStructBase
{
    /**
     * The Active
     * Meta information extracted from the WSDL
     * - documentation: Active document. - Related to column [PIECE.GP_VIVANTE].
     * - minOccurs: 0
     * @var bool
     */
    public $Active;
    /**
     * The Comment
     * Meta information extracted from the WSDL
     * - documentation: [Added 2015/01 - V1201] [Optional] - Comment on document header that can be in plain text or in RTF format - Related to column [PIECE.GP_BLOCNOTE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Comment;
    /**
     * The CurrencyId
     * Meta information extracted from the WSDL
     * - documentation: Document currency ID - Related to column [PIECE.GP_DEVISE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CurrencyId;
    /**
     * The CustomerId
     * Meta information extracted from the WSDL
     * - documentation: Customer identifier of the document - Related to column [PIECE.GP_TIERS].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CustomerId;
    /**
     * The Date
     * Meta information extracted from the WSDL
     * - documentation: Document date - Related to column [PIECE.GP_DATEPIECE].
     * - minOccurs: 0
     * @var string
     */
    public $Date;
    /**
     * The InternalReference
     * Meta information extracted from the WSDL
     * - documentation: Internal reference of document - Related to column [PIECE.GP_REFINTERNE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $InternalReference;
    /**
     * The Key
     * Meta information extracted from the WSDL
     * - documentation: Document key.
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\SaleDocumentKey
     */
    public $Key;
    /**
     * The OmniChannel
     * Meta information extracted from the WSDL
     * - documentation: Omni-Channel information.
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\OmniChannel
     */
    public $OmniChannel;
    /**
     * The Origin
     * Meta information extracted from the WSDL
     * - documentation: Document origin - Related to column [PIECE.GP_TYPEPROVENANCE].
     * - minOccurs: 0
     * @var string
     */
    public $Origin;
    /**
     * The SalesPersonId
     * Meta information extracted from the WSDL
     * - documentation: [Added 2014/10 - V1105] [Optional] - Seller ID. - Related to column [PIECE.GP_REPRESENTANT].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $SalesPersonId;
    /**
     * The Status
     * Meta information extracted from the WSDL
     * - documentation: [Added 2013/10 - V1105] - Document status. - Related to column [PIECE.GP_STATUTPIECE].
     * - minOccurs: 0
     * @var string
     */
    public $Status;
    /**
     * The StoreId
     * Meta information extracted from the WSDL
     * - documentation: Document store ID - Related to column [PIECE.GP_ETABLISSEMENT].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $StoreId;
    /**
     * The TaxExcludedTotalAmount
     * Meta information extracted from the WSDL
     * - documentation: Document tax-excl. amount - Related to column [PIECE.GP_TOTALHT].
     * - minOccurs: 0
     * @var float
     */
    public $TaxExcludedTotalAmount;
    /**
     * The TaxIncludedTotalAmount
     * Meta information extracted from the WSDL
     * - documentation: Document tax-incl. amount - Related to column [PIECE.GP_TOTALTTC].
     * - minOccurs: 0
     * @var float
     */
    public $TaxIncludedTotalAmount;
    /**
     * The TotalQuantity
     * Meta information extracted from the WSDL
     * - documentation: Document total quantity - Related to column [PIECE.GP_TOTALQTEFACT].
     * - minOccurs: 0
     * @var float
     */
    public $TotalQuantity;
    /**
     * The UserDefinedDates
     * Meta information extracted from the WSDL
     * - documentation: Document user-defined dates - Related to column [PIECE.GP_DATELIBREPIECEx].
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserDefinedDate
     */
    public $UserDefinedDates;
    /**
     * The UserDefinedTables
     * Meta information extracted from the WSDL
     * - documentation: Document user-defined tables - Related to column [PIECE.GP_LIBREPIECEx].
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserDefinedTable
     */
    public $UserDefinedTables;
    /**
     * The UserFields
     * Meta information extracted from the WSDL
     * - documentation: Document user fields.
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserField
     */
    public $UserFields;
    /**
     * The WarehouseId
     * Meta information extracted from the WSDL
     * - documentation: [Added 2015/02 - V1201] - Warehouse identifier of the document store - Related to column [PIECE.GP_DEPOT].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $WarehouseId;
    /**
     * Constructor method for Get_Header
     * @uses Get_Header::setActive()
     * @uses Get_Header::setComment()
     * @uses Get_Header::setCurrencyId()
     * @uses Get_Header::setCustomerId()
     * @uses Get_Header::setDate()
     * @uses Get_Header::setInternalReference()
     * @uses Get_Header::setKey()
     * @uses Get_Header::setOmniChannel()
     * @uses Get_Header::setOrigin()
     * @uses Get_Header::setSalesPersonId()
     * @uses Get_Header::setStatus()
     * @uses Get_Header::setStoreId()
     * @uses Get_Header::setTaxExcludedTotalAmount()
     * @uses Get_Header::setTaxIncludedTotalAmount()
     * @uses Get_Header::setTotalQuantity()
     * @uses Get_Header::setUserDefinedDates()
     * @uses Get_Header::setUserDefinedTables()
     * @uses Get_Header::setUserFields()
     * @uses Get_Header::setWarehouseId()
     * @param bool $active
     * @param string $comment
     * @param string $currencyId
     * @param string $customerId
     * @param string $date
     * @param string $internalReference
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\SaleDocumentKey $key
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\OmniChannel $omniChannel
     * @param string $origin
     * @param string $salesPersonId
     * @param string $status
     * @param string $storeId
     * @param float $taxExcludedTotalAmount
     * @param float $taxIncludedTotalAmount
     * @param float $totalQuantity
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserDefinedDate $userDefinedDates
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserDefinedTable $userDefinedTables
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserField $userFields
     * @param string $warehouseId
     */
    public function __construct($active = null, $comment = null, $currencyId = null, $customerId = null, $date = null, $internalReference = null, \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\SaleDocumentKey $key = null, \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\OmniChannel $omniChannel = null, $origin = null, $salesPersonId = null, $status = null, $storeId = null, $taxExcludedTotalAmount = null, $taxIncludedTotalAmount = null, $totalQuantity = null, \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserDefinedDate $userDefinedDates = null, \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserDefinedTable $userDefinedTables = null, \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserField $userFields = null, $warehouseId = null)
    {
        $this
            ->setActive($active)
            ->setComment($comment)
            ->setCurrencyId($currencyId)
            ->setCustomerId($customerId)
            ->setDate($date)
            ->setInternalReference($internalReference)
            ->setKey($key)
            ->setOmniChannel($omniChannel)
            ->setOrigin($origin)
            ->setSalesPersonId($salesPersonId)
            ->setStatus($status)
            ->setStoreId($storeId)
            ->setTaxExcludedTotalAmount($taxExcludedTotalAmount)
            ->setTaxIncludedTotalAmount($taxIncludedTotalAmount)
            ->setTotalQuantity($totalQuantity)
            ->setUserDefinedDates($userDefinedDates)
            ->setUserDefinedTables($userDefinedTables)
            ->setUserFields($userFields)
            ->setWarehouseId($warehouseId);
    }
    /**
     * Get Active value
     * @return bool|null
     */
    public function getActive()
    {
        return $this->Active;
    }
    /**
     * Set Active value
     * @param bool $active
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Header
     */
    public function setActive($active = null)
    {
        // validation for constraint: boolean
        if (!is_null($active) && !is_bool($active)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($active, true), gettype($active)), __LINE__);
        }
        $this->Active = $active;
        return $this;
    }
    /**
     * Get Comment value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getComment()
    {
        return isset($this->Comment) ? $this->Comment : null;
    }
    /**
     * Set Comment value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $comment
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Header
     */
    public function setComment($comment = null)
    {
        // validation for constraint: string
        if (!is_null($comment) && !is_string($comment)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($comment, true), gettype($comment)), __LINE__);
        }
        if (is_null($comment) || (is_array($comment) && empty($comment))) {
            unset($this->Comment);
        } else {
            $this->Comment = $comment;
        }
        return $this;
    }
    /**
     * Get CurrencyId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCurrencyId()
    {
        return isset($this->CurrencyId) ? $this->CurrencyId : null;
    }
    /**
     * Set CurrencyId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $currencyId
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Header
     */
    public function setCurrencyId($currencyId = null)
    {
        // validation for constraint: string
        if (!is_null($currencyId) && !is_string($currencyId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($currencyId, true), gettype($currencyId)), __LINE__);
        }
        if (is_null($currencyId) || (is_array($currencyId) && empty($currencyId))) {
            unset($this->CurrencyId);
        } else {
            $this->CurrencyId = $currencyId;
        }
        return $this;
    }
    /**
     * Get CustomerId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCustomerId()
    {
        return isset($this->CustomerId) ? $this->CustomerId : null;
    }
    /**
     * Set CustomerId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $customerId
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Header
     */
    public function setCustomerId($customerId = null)
    {
        // validation for constraint: string
        if (!is_null($customerId) && !is_string($customerId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($customerId, true), gettype($customerId)), __LINE__);
        }
        if (is_null($customerId) || (is_array($customerId) && empty($customerId))) {
            unset($this->CustomerId);
        } else {
            $this->CustomerId = $customerId;
        }
        return $this;
    }
    /**
     * Get Date value
     * @return string|null
     */
    public function getDate()
    {
        return $this->Date;
    }
    /**
     * Set Date value
     * @param string $date
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Header
     */
    public function setDate($date = null)
    {
        // validation for constraint: string
        if (!is_null($date) && !is_string($date)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($date, true), gettype($date)), __LINE__);
        }
        $this->Date = $date;
        return $this;
    }
    /**
     * Get InternalReference value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getInternalReference()
    {
        return isset($this->InternalReference) ? $this->InternalReference : null;
    }
    /**
     * Set InternalReference value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $internalReference
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Header
     */
    public function setInternalReference($internalReference = null)
    {
        // validation for constraint: string
        if (!is_null($internalReference) && !is_string($internalReference)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($internalReference, true), gettype($internalReference)), __LINE__);
        }
        if (is_null($internalReference) || (is_array($internalReference) && empty($internalReference))) {
            unset($this->InternalReference);
        } else {
            $this->InternalReference = $internalReference;
        }
        return $this;
    }
    /**
     * Get Key value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\SaleDocumentKey|null
     */
    public function getKey()
    {
        return isset($this->Key) ? $this->Key : null;
    }
    /**
     * Set Key value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\SaleDocumentKey $key
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Header
     */
    public function setKey(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\SaleDocumentKey $key = null)
    {
        if (is_null($key) || (is_array($key) && empty($key))) {
            unset($this->Key);
        } else {
            $this->Key = $key;
        }
        return $this;
    }
    /**
     * Get OmniChannel value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\OmniChannel|null
     */
    public function getOmniChannel()
    {
        return isset($this->OmniChannel) ? $this->OmniChannel : null;
    }
    /**
     * Set OmniChannel value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\OmniChannel $omniChannel
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Header
     */
    public function setOmniChannel(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\OmniChannel $omniChannel = null)
    {
        if (is_null($omniChannel) || (is_array($omniChannel) && empty($omniChannel))) {
            unset($this->OmniChannel);
        } else {
            $this->OmniChannel = $omniChannel;
        }
        return $this;
    }
    /**
     * Get Origin value
     * @return string|null
     */
    public function getOrigin()
    {
        return $this->Origin;
    }
    /**
     * Set Origin value
     * @uses \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\DocumentOrigin::valueIsValid()
     * @uses \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\DocumentOrigin::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $origin
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Header
     */
    public function setOrigin($origin = null)
    {
        // validation for constraint: enumeration
        if (!\FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\DocumentOrigin::valueIsValid($origin)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\DocumentOrigin', is_array($origin) ? implode(', ', $origin) : var_export($origin, true), implode(', ', \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\DocumentOrigin::getValidValues())), __LINE__);
        }
        $this->Origin = $origin;
        return $this;
    }
    /**
     * Get SalesPersonId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSalesPersonId()
    {
        return isset($this->SalesPersonId) ? $this->SalesPersonId : null;
    }
    /**
     * Set SalesPersonId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $salesPersonId
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Header
     */
    public function setSalesPersonId($salesPersonId = null)
    {
        // validation for constraint: string
        if (!is_null($salesPersonId) && !is_string($salesPersonId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($salesPersonId, true), gettype($salesPersonId)), __LINE__);
        }
        if (is_null($salesPersonId) || (is_array($salesPersonId) && empty($salesPersonId))) {
            unset($this->SalesPersonId);
        } else {
            $this->SalesPersonId = $salesPersonId;
        }
        return $this;
    }
    /**
     * Get Status value
     * @return string|null
     */
    public function getStatus()
    {
        return $this->Status;
    }
    /**
     * Set Status value
     * @uses \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\DocumentStatus::valueIsValid()
     * @uses \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\DocumentStatus::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $status
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Header
     */
    public function setStatus($status = null)
    {
        // validation for constraint: enumeration
        if (!\FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\DocumentStatus::valueIsValid($status)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\DocumentStatus', is_array($status) ? implode(', ', $status) : var_export($status, true), implode(', ', \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\DocumentStatus::getValidValues())), __LINE__);
        }
        $this->Status = $status;
        return $this;
    }
    /**
     * Get StoreId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getStoreId()
    {
        return isset($this->StoreId) ? $this->StoreId : null;
    }
    /**
     * Set StoreId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $storeId
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Header
     */
    public function setStoreId($storeId = null)
    {
        // validation for constraint: string
        if (!is_null($storeId) && !is_string($storeId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($storeId, true), gettype($storeId)), __LINE__);
        }
        if (is_null($storeId) || (is_array($storeId) && empty($storeId))) {
            unset($this->StoreId);
        } else {
            $this->StoreId = $storeId;
        }
        return $this;
    }
    /**
     * Get TaxExcludedTotalAmount value
     * @return float|null
     */
    public function getTaxExcludedTotalAmount()
    {
        return $this->TaxExcludedTotalAmount;
    }
    /**
     * Set TaxExcludedTotalAmount value
     * @param float $taxExcludedTotalAmount
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Header
     */
    public function setTaxExcludedTotalAmount($taxExcludedTotalAmount = null)
    {
        // validation for constraint: float
        if (!is_null($taxExcludedTotalAmount) && !(is_float($taxExcludedTotalAmount) || is_numeric($taxExcludedTotalAmount))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($taxExcludedTotalAmount, true), gettype($taxExcludedTotalAmount)), __LINE__);
        }
        $this->TaxExcludedTotalAmount = $taxExcludedTotalAmount;
        return $this;
    }
    /**
     * Get TaxIncludedTotalAmount value
     * @return float|null
     */
    public function getTaxIncludedTotalAmount()
    {
        return $this->TaxIncludedTotalAmount;
    }
    /**
     * Set TaxIncludedTotalAmount value
     * @param float $taxIncludedTotalAmount
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Header
     */
    public function setTaxIncludedTotalAmount($taxIncludedTotalAmount = null)
    {
        // validation for constraint: float
        if (!is_null($taxIncludedTotalAmount) && !(is_float($taxIncludedTotalAmount) || is_numeric($taxIncludedTotalAmount))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($taxIncludedTotalAmount, true), gettype($taxIncludedTotalAmount)), __LINE__);
        }
        $this->TaxIncludedTotalAmount = $taxIncludedTotalAmount;
        return $this;
    }
    /**
     * Get TotalQuantity value
     * @return float|null
     */
    public function getTotalQuantity()
    {
        return $this->TotalQuantity;
    }
    /**
     * Set TotalQuantity value
     * @param float $totalQuantity
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Header
     */
    public function setTotalQuantity($totalQuantity = null)
    {
        // validation for constraint: float
        if (!is_null($totalQuantity) && !(is_float($totalQuantity) || is_numeric($totalQuantity))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($totalQuantity, true), gettype($totalQuantity)), __LINE__);
        }
        $this->TotalQuantity = $totalQuantity;
        return $this;
    }
    /**
     * Get UserDefinedDates value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserDefinedDate|null
     */
    public function getUserDefinedDates()
    {
        return isset($this->UserDefinedDates) ? $this->UserDefinedDates : null;
    }
    /**
     * Set UserDefinedDates value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserDefinedDate $userDefinedDates
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Header
     */
    public function setUserDefinedDates(\FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserDefinedDate $userDefinedDates = null)
    {
        if (is_null($userDefinedDates) || (is_array($userDefinedDates) && empty($userDefinedDates))) {
            unset($this->UserDefinedDates);
        } else {
            $this->UserDefinedDates = $userDefinedDates;
        }
        return $this;
    }
    /**
     * Get UserDefinedTables value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserDefinedTable|null
     */
    public function getUserDefinedTables()
    {
        return isset($this->UserDefinedTables) ? $this->UserDefinedTables : null;
    }
    /**
     * Set UserDefinedTables value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserDefinedTable $userDefinedTables
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Header
     */
    public function setUserDefinedTables(\FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserDefinedTable $userDefinedTables = null)
    {
        if (is_null($userDefinedTables) || (is_array($userDefinedTables) && empty($userDefinedTables))) {
            unset($this->UserDefinedTables);
        } else {
            $this->UserDefinedTables = $userDefinedTables;
        }
        return $this;
    }
    /**
     * Get UserFields value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserField|null
     */
    public function getUserFields()
    {
        return isset($this->UserFields) ? $this->UserFields : null;
    }
    /**
     * Set UserFields value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserField $userFields
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Header
     */
    public function setUserFields(\FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserField $userFields = null)
    {
        if (is_null($userFields) || (is_array($userFields) && empty($userFields))) {
            unset($this->UserFields);
        } else {
            $this->UserFields = $userFields;
        }
        return $this;
    }
    /**
     * Get WarehouseId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getWarehouseId()
    {
        return isset($this->WarehouseId) ? $this->WarehouseId : null;
    }
    /**
     * Set WarehouseId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $warehouseId
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Header
     */
    public function setWarehouseId($warehouseId = null)
    {
        // validation for constraint: string
        if (!is_null($warehouseId) && !is_string($warehouseId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($warehouseId, true), gettype($warehouseId)), __LINE__);
        }
        if (is_null($warehouseId) || (is_array($warehouseId) && empty($warehouseId))) {
            unset($this->WarehouseId);
        } else {
            $this->WarehouseId = $warehouseId;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Header
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
