<?php

namespace FiloBlu\CegidY2\Tools;

/**
 * Class Utils
 */
class Utils
{
    /**
     * @param string $service
     * @return string
     */
    public static function getServiceId($service)
    {
        $key = '';
        $len = strlen($service);
        for ($i = 0; $i < $len; $i++) {

            $c = $service[$i];
            if ($c < 'a') {
                $c = strtolower($c);
                $key .= ($key === '') ? $c : "_{$c}";
                continue;
            }
            $key .= $c;
        }

        return $key;
    }
    /**
     *
     */
    public static function getConfiguration()
    {
        return include __DIR__ . '/../endpoints.php';
    }

    /**
     * @param $className
     */
    public static function dummyAutoloader($className)
    {
        if ($className === 'Magento\Framework\Component\ComponentRegistrar') {
            eval("namespace Magento\Framework\Component; class ComponentRegistrar { const MODULE = 'module'; public static function register(\$a, \$b, \$c) {} }");
        }
    }

    /**
     *
     */
    public static function startSuppressMagento()
    {
        spl_autoload_register([self::class, 'dummyAutoloader']);
    }

    /**
     *
     */
    public static function endSuppressMagento()
    {
        spl_autoload_unregister([self::class, 'dummyAutoloader']);
    }

    /**
     * @param $dir
     * @return bool
     */
    public static function rrmdir($dir)
    {
        $files = array_diff(scandir($dir), ['.', '..']);
        foreach ($files as $file) {
            (is_dir("$dir/$file")) ? rrmdir("$dir/$file") : unlink("$dir/$file");
        }
        return rmdir($dir);
    }


    /**
     * @param $src
     * @param $dst
     */
    public static function rcopy($src, $dst)
    {
        $dir = opendir($src);
        if (!mkdir($dst) && !is_dir($dst)) {
            throw new RuntimeException(sprintf('Directory "%s" was not created', $dst));
        }
        while (($file = readdir($dir))) {
            if (($file !== '.') && ($file !== '..')) {
                if (is_dir($src . '/' . $file)) {
                    rcopy($src . '/' . $file, $dst . '/' . $file);
                } else {
                    copy($src . '/' . $file, $dst . '/' . $file);
                }
            }
        }
        closedir($dir);
    }
}